workflow:
  rules:
    - if: $CI_PIPELINE_SOURCE != "merge_request_event"

stages:
  - build docker

.docker_build:
  image: docker:stable
  retry: 2
  before_script:
    - echo $CI_REGISTRY
    - docker login -u $CI_REGISTRY_USER -p $CI_REGISTRY_PASSWORD $CI_REGISTRY
  script:
    - |
      docker build \
        --build-arg KEYCLOAK_URL \
        --build-arg REALM \
        --build-arg CLIENT_ID \
        --build-arg BASE_URL \
        --tag $CI_REGISTRY/$CI_PROJECT_PATH:$IMAGE_TAG .
    - docker push $CI_REGISTRY/$CI_PROJECT_PATH:$IMAGE_TAG
  after_script:
    - docker rmi $CI_REGISTRY/$CI_PROJECT_PATH:$IMAGE_TAG

docker_build_test:
  stage: build docker
  extends: .docker_build
  variables:
    IMAGE_TAG: $CI_COMMIT_SHORT_SHA
  rules:
    - if: $CI_COMMIT_BRANCH != $CI_DEFAULT_BRANCH
      when: manual
    - if: $CI_COMMIT_BRANCH == $CI_DEFAULT_BRANCH
      when: never
  tags:
    - docker

docker_build_prod:
  stage: build docker
  extends: .docker_build
  variables:
    IMAGE_TAG: $CI_COMMIT_TAG
  rules:
    - if: $CI_COMMIT_TAG
      when: manual
  tags:
    - docker